> This page is for Developer Documentation.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.benchling.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.benchling.com/_mcp/server.

# Create Attachment

POST https://{tenant_name}.benchling.com/api/v3/attachment
Content-Type: application/json

Create Attachment.

Reference: https://docs.benchling.com/docs/api/benchling-api/attachment/create

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Headers

- `EARLY-ACCESS` (string, optional) — Set to true to access beta operations via /api/v3.

### Body (application/json)

This endpoint expects a CreateAttachmentInput.

- `scratchFileId` (string, required) — ID of the ScratchFile to copy into the Attachment.
- `generateImagePreview` (boolean, optional) — Whether to generate an image preview for the attachment. Defaults to false.
- `generatePdfPreview` (boolean, optional) — Whether to generate a PDF preview for the attachment. Defaults to false.

## Response

### 201

Created

- `__typename` (string, optional)
- `createdAt` (string, optional)
- `creator` (PrincipalRef, optional, nullable)
- `downloadUrl` (string, optional, nullable) — A pre-signed download URL. The URL may be null if the file did not upload successfully.
- `id` (string, optional)
- `mimeType` (string, optional) — The MIME type of the file, e.g. 'image/jpeg'
- `name` (string, optional)
- `uploadStatus` (enum, optional) — Whether the attachment uploaded successfully, failed to upload or is still uploading.
  - Allowed values: `SUCCEEDED`, `FAILED_VALIDATION`, `IN_PROGRESS`, `NOT_UPLOADED`

## Errors

### 400 Attachment Create Request Bad Request Error

Bad Request

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 403 Attachment Create Request Forbidden Error

Forbidden

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 404 Attachment Create Request Not Found Error

Not Found

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 409 Attachment Create Request Conflict Error

Conflict

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 429 Attachment Create Request Too Many Requests Error

Too Many Requests

- `detail` (TooManyRequestsErrorBodyDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)
- `violated-policies` (list of enum, optional) — The budget policies that rejected the request, in canonical order: `user`, `integration`, then `tenant`.
  - Allowed values: `user`, `integration`, `tenant`

### 500 Attachment Create Request Internal Server Error

Internal Server Error

- `detail` (InternalServerErrorBodyDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `errorId` (string, optional)

## Types

### PrincipalRef

- `__typename` (string, optional)
- `id` (string, optional)

### GeneralErrorDetail

### TooManyRequestsErrorBodyDetail

### InternalServerErrorBodyDetail

## Examples

**Request**

```json
{
  "scratchFileId": "scratchFileId"
}
```

**Response**

```json
{
  "__typename": "__typename",
  "createdAt": "createdAt",
  "creator": {
    "__typename": "__typename",
    "id": "id"
  },
  "downloadUrl": "downloadUrl",
  "id": "id",
  "mimeType": "mimeType",
  "name": "name",
  "uploadStatus": "SUCCEEDED"
}
```

**SDK Code**

```python
import requests

url = "https://{tenant_name}.benchling.com/api/v3/attachment"

payload = { "scratchFileId": "scratchFileId" }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://{tenant_name}.benchling.com/api/v3/attachment';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"scratchFileId":"scratchFileId"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```